package org.nwoca.ssdt.tools.html2wiki;

import java.util.regex.*;

class ReplaceTransformer implements Transformer {
    
    private Pattern replace;
    private String replacement;
    
    public ReplaceTransformer(String regex, String replacement) {
        replace = Pattern.compile(regex);
        this.replacement = replacement;
        
    }
    public void apply(StringBuffer buffer) {
        Matcher matcher = replace.matcher(buffer);
        
        boolean first = true;
        while (matcher.find(first ? 0 : matcher.start() + replacement.length())) {
            buffer.replace(matcher.start(),matcher.end(),replacement);
            first = false; 
        }        
    }
    
    public String toString() {
        return "Replace: " + replace.pattern() + " with " +replacement;
    }
    
    
}